include "Zeropage.inc"
include "Vram.inc"

ext CharColors_

Char_Space equ 0

pDestination equ ZW0


; ptr<byte> VramAddress(byte x, byte y)
dseg
VramAddress_@Param0: public	VramAddress_@Param0
VramAddress_.x_:
    defs 1
VramAddress_@Param1: public	VramAddress_@Param1
VramAddress_.y_:
    defs 1
cseg
VramAddress_: public VramAddress_
    pha
        lda	VramAddress_.y_
        asl	a ; *2
        asl	a ; *4
        clc|adc	VramAddress_.y_ ; *5

        sta <pDestination
        lda #0
        sta <pDestination+1
        ;	w = w << 3	[3]
        asl	<pDestination | rol <pDestination+1 ; *10
        asl	<pDestination | rol <pDestination+1 ; *20
        asl	<pDestination | rol <pDestination+1 ; *40

        lda <pDestination | clc|adc VramAddress_.x_ | sta <pDestination
        lda <pDestination+1 | adc #0 | sta <pDestination+1

        lda <pDestination | clc|adc #low Vram | tay
        lda <pDestination+1 | adc #high Vram | tax
	pla
rts


; ptr<byte> Put(ptr<byte> pVram, byte c);
dseg
Put_@Param0: public Put_@Param0
Put_pVram:
    defw 0
Put_@Param1: public Put_@Param1
Put_c:
    defb 0
cseg
Put_: public Put_
    pha
        lda Put_pVram
        sta <ZW0
        lda Put_pVram+1
        sta <ZW0+1
        lda Put_c
        ldy #0
        sta (<ZW0),y
        tax
        lda <ZW0+1
        clc|adc #high(ColorMap-Vram)
        sta <ZW0+1
        lda CharColors_,x
        sta (<ZW0),y
        
        lda Put_pVram | clc|adc #1 | tay
        lda Put_pVram+1 | adc #0 | tax
    pla
rts


; ptr<byte> PrintC(ptr<byte> pVram, byte c);
dseg
PrintC_@Param0: public PrintC_@Param0
PrintC_.pVram_:	defs 2
PrintC_@Param1: public PrintC_@Param1
PrintC_.c_:	defs 1
cseg
CharTable:
    defb ' -0123456789ABCEFGHIMNOPRSTUV'
PrintC_: public PrintC_
    pha
        lda PrintC_@Param1
        ldx #0
        do
            cmp CharTable,x
            beq PrintC_exit
            inx
            cpx #29
        while ne | wend
        ldx #Char_Space
        PrintC_exit:        
        lda PrintC_@Param0 | sta <pDestination
        lda PrintC_@Param0+1 | sta <pDestination+1
        txa
        ldy #0
        sta (<pDestination),y
        ldy #0
        sta (<pDestination),y
        tax
        lda <pDestination+1
        clc|adc #high(ColorMap-Vram)
        sta <pDestination+1
        lda #1
        sta (<pDestination),y

        lda <pDestination | clc|adc #1 | tay
        lda <pDestination+1 | adc #-high(ColorMap-Vram) | tax
    pla
rts
